-- =============================================================================================================
-- *
-- * Copyright (c) Mike
-- *
-- * File Name: addr_decoder.vhd
-- *
-- * Version: V1.0
-- *
-- * Release Date:
-- *
-- * Author(s): M.Freeman
-- *
-- * Description: address decoder
-- *
-- * Conditions of Use: THIS CODE IS COPYRIGHT AND IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, INCLUDING,
-- *                    BUT NOT LIMITED TO, ANY IMPLIED WARRANTY OF MERCHANTABILITY AND FITNESS FOR A
-- *                    PARTICULAR PURPOSE.
-- *
-- * Notes:
-- *
-- =============================================================================================================

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity addr_decoder is
Port ( 
  addr : in  STD_LOGIC_VECTOR (11 downto 0);
  wr   : in  STD_LOGIC;
  en   : in  STD_LOGIC;
  ce   : out STD_LOGIC;
  tp   : out STD_LOGIC );
end addr_decoder;

architecture addr_decoder_arch of addr_decoder is

begin

  ce <= addr(11) and addr(10) and addr(9)  and addr(8)  and addr(7) and
	     addr(6)  and addr(5)  and addr(4)  and addr(3)  and addr(2) and
	  	  addr(1)  and addr(0)  and wr       and en;
		  
  tp <= addr(11) and addr(10) and addr(9)  and addr(8)  and addr(7) and
	     addr(6)  and addr(5)  and addr(4)  and addr(3)  and addr(2) and
	  	  addr(1)  and not addr(0)  and wr   and en;	
		  
end addr_decoder_arch;

